# -*-python-*-

import httplib
import urllib

from elementtree.ElementTree import XML
from pdis.xpath import compile

class zonetag :

    def __init__ (self, apptoken, usertoken) :
        self.__usertoken = usertoken
        self.__apptoken  = apptoken

        self.__zonetag = {'host':u"zonetag.research.yahoo.com",
                          'endpoint':u"/8rlv2l5An3TL2Qs/cellapiExternal.php?"}

        self.__local = {'host':u'api.local.yahoo.com',
                        'endpoint':u'/MapsService/V1/geocode'}
        
    #
    #
    #
    
    def locate_celltower (self, mcc, mnc, lac, cellid) :
        results=10
        
        params = {'cellid':cellid, 'lac':lac, 'mnc':mnc, 'mcc':mcc, 'usertoken':self.__usertoken, 'apptoken':self.__apptoken, 'results':10}
        url    = "%s?%s" % (self.__zonetag['endpoint'], urllib.urlencode(params))

        conn = httplib.HTTPConnection(self.__zonetag['host'])
        conn.request('GET', url)

        res = conn.getresponse()
        content = res.read()

        results = []
        xml = XML(content)
        
        xp = compile("/rsp/Location")

        for loc in xp.evaluate(xml) :

            data = {}
    
            if loc.find('State') == None :
                continue
    
            for item in ('Country', 'State', 'City', 'Zipcode') :
                value = loc.find(item)

                if value != None :
                    data[item.lower()] = value.text

                results.append(data)

        return results
    
    #
    #
    #

    def geocode_celltower (self, mcc, mnc, lac, cellid) :

        places = self.locate_celltower(mcc, mnc, lac, cellid)
        
        for place in places :

            if not place.has_key('zipcode') :
                continue

            addr = "%s %s %s %s" % (place['city'], place['state'], place['country'], place['zipcode'])

            params = urllib.urlencode({"appid":"restobook", "location":addr})
            req    = "%s?%s" % (self.__local['endpoint'], params)

            conn = httplib.HTTPConnection(self.__local['host'])
            conn.request('GET', req)
    
            res = conn.getresponse()
            content = res.read()
            
            xml = XML(content)
            res = xml.find("{urn:yahoo:maps}Result")

            if res == None :
                continue

            lat = res.find("{urn:yahoo:maps}Latitude")
            lon = res.find("{urn:yahoo:maps}Longitude")    

            return (lat.text, lon.text)

    #
    #
    #
    
if __name__ == "__main__" :

    usertoken = sys.argv[1]
    apptoken  = sys.argv[2]

    zt = zonetag(apptoken, usertoken)
    print zt.geocode_celltower()
